=== debian/changelog ===
libsmb2 (6.2+dfsg-2+deb13u1) trixie; urgency=medium

  * Import upstream patches to fix CVE-2025-57632
    - When processing SMB2 chained PDUs (NextCommand), libsmb2
      repeatedly calls smb2_add_iovector() to append to a
      fixed-size iovec array without checking the upper bound
      of v->niov (SMB2_MAX_VECTORS=256)
  * d/p/CVE-2025-57632-pt*.patch: Import upstream patches to fix CVE
  * d/p/CVE-2025-57632-pt2.patch: Backport patch and Update hunks' offsets
  * d/p/CVE-2025-57632-pt3.patch: Backport patch and Update hunks' offsets
  * d/p/CVE-2025-57632-pt4.patch: Backport patch and Change hunk to
    reflect new code indentation

 -- Matheus Polkorny <mpolkorny@gmail.com>  Fri, 17 Oct 2025 20:26:34 -0300

libsmb2 (6.2+dfsg-2) unstable; urgency=medium

  * d/control: Bump Standards-Version to 4.7.2 (no changes)
  * d/copyright:
    - Bump copyright year in debian/*
    - Remove physical address from fsf license
  * d/patches:
    - 10-Fix-compiler-warning.patch: New Upstream patch
    - 20-Handle-a-bunch-of-other-compiler-warnings.patch: New Upstream patch

 -- Matheus Polkorny <mpolkorny@gmail.com>  Thu, 03 Apr 2025 15:20:58 -0300

libsmb2 (6.2+dfsg-1) unstable; urgency=medium

  * New upstream version 6.2+dfsg
    - Remove /lib/ps2/irx_imports.h due to license incompatibility
  * d/copyright:
    - Add lib/ps2/irx_imports.h to Files-Excluded
    - Change license name from MIT to Expat
  * d/watch: Update to dfsg and use github api

 -- Matheus Polkorny <mpolkorny@gmail.com>  Wed, 19 Mar 2025 11:04:47 -0300

libsmb2 (6.2-1) unstable; urgency=medium

  * Initial release. (Closes: #1068113)
  * New upstream version 6.2

 -- Matheus Polkorny <mpolkorny@gmail.com>  Thu, 26 Dec 2024 12:15:24 -0300
