=== debian/control ===
Source: libsmb2
Section: libs
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Matheus Polkorny <mpolkorny@gmail.com>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libkrb5-dev,
Standards-Version: 4.7.2
Homepage: https://github.com/sahlberg/libsmb2
Vcs-Browser: https://salsa.debian.org/pkg-security-team/libsmb2
Vcs-Git: https://salsa.debian.org/pkg-security-team/libsmb2.git

Package: libsmb2-6
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Libsmb2 is a SMB2/3 client library (library)
 for accessing or serving SMB2/SMB3 shares on a network.
 It is high performance and fully async. It supports both zero-copy
 for SMB READ/WRITE commands as well as compounded commands.
 .
 This package contains the shared library.

Package: libsmb2-dev
Section: libdevel
Architecture: any
Depends:
 libsmb2-6 (= ${binary:Version}),
 ${misc:Depends},
Description: Libsmb2 is a SMB2/3 client library (development)
 for accessing or serving SMB2/SMB3 shares on a network.
 It is high performance and fully async. It supports both zero-copy
 for SMB READ/WRITE commands as well as compounded commands.
 .
 This package contains the development files.
