=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

execute_after_dh_install:
	rm -f debian/tmp/usr/lib/*/*.la

# Skipping tests for now
# To run these tests, an SMB server must export a share, and two
# configuration files (/tests/NTLM and tests/setup.local) need to be created

override_dh_auto_test:
	echo "Skipping tests"
