=== debian/watch ===
version=4
opts="searchmode=plain, \
      filenamemangle=s%v?@ANY_VERSION@%@PACKAGE@-$1.tar.xz%, \
      dversionmangle=s/@DEB_EXT@//, \
      repacksuffix=+dfsg" \
https://api.github.com/repos/sahlberg/libsmb2/tags?per_page=100 \
https://api.github.com/repos/[^/]+/[^/]+/tarball/refs/tags/@PACKAGE@?@ANY_VERSION@
